Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

# stk::PoleZero Class Reference

STK one-pole, one-zero filter class. More...

`#include <PoleZero.h>`

Inheritance diagram for stk::PoleZero:

List of all members.

## Public Member Functions
| PoleZero ()
| Default constructor creates a first-order pass-through filter.
| ~PoleZero ()
| Class destructor.
void | setB0 (StkFloat b0)
| Set the b[0] coefficient value.
void | setB1 (StkFloat b1)
| Set the b[1] coefficient value.
void | setA1 (StkFloat a1)
| Set the a[1] coefficient value.
void | setCoefficients (StkFloat b0, StkFloat b1, StkFloat a1, bool clearState=false)
| Set all filter coefficients.
void | setAllpass (StkFloat coefficient)
| Set the filter for allpass behavior using coefficient.
void | setBlockZero (StkFloat thePole=0.99)
| Create a DC blocking filter with the given pole position in the z-plane.
StkFloat | lastOut (void) const
| Return the last computed output value.
StkFloat | tick (StkFloat input)
| Input one sample to the filter and return one output.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.

## Detailed Description

STK one-pole, one-zero filter class.

This class implements a one-pole, one-zero digital filter. A method is provided for creating an allpass filter with a given coefficient. Another method is provided to create a DC blocking filter.

by Perry R. Cook and Gary P. Scavone, 1995 - 2010.

## Member Function Documentation

void stk::PoleZero::setAllpass | ( | StkFloat | coefficient | ) |

Set the filter for allpass behavior using coefficient.

This method uses coefficient to create an allpass filter, which has unity gain at all frequencies. Note that the coefficient magnitude must be less than one to maintain stability.

void stk::PoleZero::setBlockZero | ( | StkFloat | thePole = `0.99` | ) |

Create a DC blocking filter with the given pole position in the z-plane.

This method sets the given pole position, together with a zero at z=1, to create a DC blocking filter. thePole should be close to one to minimize low-frequency attenuation.

StkFrames & stk::PoleZero::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0` |
| ) |  |  | `[inline, virtual]`

Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.

The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Filter.

The documentation for this class was generated from the following file:

- PoleZero.h

The Synthesis ToolKit in C++ (STK)
©1995-2010 Perry R. Cook and Gary P. Scavone. All Rights Reserved.